Bug 1593361 - Update kernel-rt timer wheel code
Summary: Update kernel-rt timer wheel code
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: kernel-rt
Version: 7.6
Hardware: x86_64
OS: Linux
unspecified
urgent
Target Milestone: rc
: 7.7
Assignee: Daniel Bristot de Oliveira
QA Contact: Qiao Zhao
Jaroslav Klech
URL:
Whiteboard:
Depends On:
Blocks: 1550584 1649541 1723499 1723502
TreeView+ depends on / blocked
 
Reported: 2018-06-20 16:21 UTC by Daniel Bristot de Oliveira
Modified: 2019-08-06 12:36 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
.The RHEL 7 kernel-rt timer wheel has been updated to a non-cascading timer wheel The current timer wheel has been switched to a non-cascading wheel which improves the timer subsystem and reduces the overheads on many operations. With the backport of the non-cascading timer wheel, kernel-rt is very close to the upstream kernel in enabling the backport of future improvements.
Clone Of:
Environment:
Last Closed: 2019-08-06 12:35:28 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2019:2043 None None None 2019-08-06 12:36:10 UTC

Description Daniel Bristot de Oliveira 2018-06-20 16:21:53 UTC
Description of problem:

The ktimersoftirq is waking up every time the timer interrupt takes place - even when there is no timer to be handled. This behavior is causing a problem of latency for the kvm-rt workload.

The solution to this problem is the integration of the upstream's -rt specific patch [1].

At the moment of the kvm-rt BZ (BZ1550584) report, I tested [1] upstream, and it worked fine. However, it depended on the timer wheel rework [2]. And so, I started backporting the timer wheel rework to the kernel-rt.

The timer wheel rework patch set is mostly done now, and it will be ready to be posted soon. However, bugs were found in [1], making it non-ready for the upstream -rt kernel, so we cannot integrate it in our kernel as well.

So we decided to split the BUG into two bugs:

The enhance BZ backporting the timer wheel rework (this one)
The BUG fix BZ, to integrate the final version of [1] #BZ1550584

[1] https://patchwork.kernel.org/patch/10263111/
[2] https://patchwork.kernel.org/patch/9183973/


Version-Release number of selected component (if applicable):
RHEL 7.5 kernel

Comment 11 Daniel Bristot de Oliveira 2019-05-24 06:45:15 UTC
Hi Jaroslav!

It is still accurate, thanks for the changes, looks better now!

-- Daniel

Comment 12 Jaroslav Klech 2019-05-28 09:23:29 UTC
(In reply to Daniel Bristot de Oliveira from comment #11)
> Hi Jaroslav!
> 
> It is still accurate, thanks for the changes, looks better now!
> 
> -- Daniel

Thanks for your verification. By the way, I moved the "." back to the beginning. It is due to AsciiDoc markup, the title must start with a dot.

--Jaroslav

Comment 14 errata-xmlrpc 2019-08-06 12:35:28 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2019:2043


Note You need to log in before you can comment on or make changes to this bug.